import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.*;
import javax.swing.border.TitledBorder;

public class NetWatcher extends JFrame {

//  MessagePanel msgp;
  JFrame progressBase;
  JProgressBar code_bar;
  JTextArea jta =
    new JTextArea("written by ryuji(ryuji@ads.ie.u-ryukyu.ac.jp)", 20, 80);
  String lineTerm = System.getProperty("line.separator");
  
  NetWatcher(){
    progressCfg();
    this.setTitle("Net Watcher"); //Title setting
    menuCfg();

    code_bar.setValue(50);
//    msgp = new MessagePanel();
    code_bar.setValue(80);
//    this.getContentPane().add(msgp, BorderLayout.CENTER);
    JScrollPane scroll = new JScrollPane(jta);
    this.getContentPane().add(scroll, BorderLayout.CENTER);
    this.addWindowListener(new GoodBye());

    code_bar.setValue(100);
    progressBase.dispose();

    this.pack();
    this.setVisible(true);
  }

  void progressCfg() {
    progressBase = new JFrame();
    code_bar = new JProgressBar(0, 100);
    java.awt.Dimension scrSize = 
      java.awt.Toolkit.getDefaultToolkit().getScreenSize();
    int barWidth = 400;
    int barHeight = 80;

    progressBase.getContentPane().add(code_bar, BorderLayout.SOUTH);
    progressBase.getContentPane().add(new JLabel("now loading..."),
				      BorderLayout.NORTH);
    progressBase.pack();
    progressBase.setVisible(true);
    progressBase.setBounds(scrSize.width/2 - barWidth/2, 
			   scrSize.height/2 - barHeight/2,
			   barWidth, barHeight);
  }

  JMenuBar menuCfg() {
    JMenuBar mb = new JMenuBar();
    JMenu file = new JMenu("File");
    JMenuItem quit = new JMenuItem("Exit");

    JMenu cmd = new JMenu("Command");
    JMenuItem fin = new JMenuItem("Finger");
    JMenuItem look = new JMenuItem("Lookup");
    JMenuItem fetch = new JMenuItem("FetchURL");

    this.setJMenuBar(mb);
    mb.add(file);
    mb.add(cmd);
    file.add(quit);
    cmd.add(fin);
    cmd.add(look);
    cmd.add(new JSeparator());
    cmd.add(fetch);
    quit.addActionListener(new GoodBye());
    fin.addActionListener(new invokeCmd());
    look.addActionListener(new invokeCmd());
    fetch.addActionListener(new invokeCmd());
    
    return mb;
  }

  void invoke(String cmd){
    String[] messages = new String[1];
    jta.setText("--- selected commmand is " + cmd + " ---" + lineTerm);

    if (cmd.equalsIgnoreCase("finger")) { // if finger command
      jta.setEditable(false);
      Finger fin = new Finger();

      JTextField tf = new JTextField("localhost");
      tf.setBorder(new TitledBorder("input Host Name"));
      Object[] obj = {tf};
      int ans = JOptionPane.showConfirmDialog(new JPanel(), obj, "Host Name",
					      JOptionPane.OK_CANCEL_OPTION);
      if(ans == 0)
	messages = fin.run(tf.getText());
      else
	return;

    } else if (cmd.equalsIgnoreCase("lookup")) { // if lookup command
      jta.setEditable(false);
      Lookup look = new Lookup();

      JTextField tf = new JTextField("localhost");
      Object[] obj = {new JLabel("input Host Name/IP Address"), tf};
      int ans = JOptionPane.showConfirmDialog(new JPanel(), obj, "Host Name",
					      JOptionPane.OK_CANCEL_OPTION);
      if(ans == 0)
	messages = look.run(tf.getText());
      else
	return;

    } else if (cmd.equalsIgnoreCase("FetchURL")) { // if FetchURL command
      FetchURL fetch = new FetchURL();

      JTextField tf = new JTextField("http://localhost");
      Object[] obj = {new JLabel("input Host Name"), tf};
      int ans = JOptionPane.showConfirmDialog(new JPanel(), obj, "Host Name",
					      JOptionPane.OK_CANCEL_OPTION);
      if(ans == 0)
	messages = fetch.run(tf.getText());
      else
	return;
    }

    for(int i = 0; i < messages.length; i++) {
      jta.append(messages[i] + lineTerm);
    }
  }

  public static void main(String[] args) {
    NetWatcher doIt = new NetWatcher();
  }

  protected class invokeCmd implements ActionListener {
    public void actionPerformed(ActionEvent even) {
      String command = even.getActionCommand();
      System.out.println("command is " + command);
//      msgp.invoke(command);
      invoke(command);
    }
  }

  protected class GoodBye extends WindowAdapter implements ActionListener {
    public void windowClosing(WindowEvent even) {
      Terminator();
    }
    public void actionPerformed(ActionEvent even) {
      Terminator();
    }
  }

  protected void Terminator() {
    System.exit(0);
  }
}
